#include <ppl.h>
#include <iostream>
#include <sstream>

using namespace Concurrency;
using namespace std;

// task_group_status ü Ʈ  ȯ
std::wstring get_status_string(task_group_status status)
{
    switch (status)
    {
    case not_complete:
        return L"not_complete";

    case completed:
        return L"completed";

    case canceled:
        return L"canceled";
    }
    return L"";
}

// ۾ Լ
bool work(int index)
{
    if (index == 100)
        return false;

    return true;
}

int wmain()
{
    // θ ½ũ ׷ tg1 
    structured_task_group tg1;

    // ø ½ũ ׷ ϴ ½ũ t1 
    auto t1 = make_task([&tg1] {

        // ø ½ũ ׷ tg2 
        structured_task_group tg2;

        // ڽ ½ũ t4 
        auto t4 = make_task([&] {
            for (int i = 0; i < 1000; ++i)
            {
                // ۾ Լ ϰ   false  
                // ½ũ ׷ ۾  û  ½ũ 
                bool succeeded = work(i);
                if (!succeeded)
                {
                    wcout << L"Canceling tg1..." << endl;
                    // θ ½ũ ׷ 
                    tg1.cancel();
                    break;
                }
            }
        });

        // ڽ ½ũ t5 
        auto t5 = make_task([&] {
            for (int i = 0; i < 1000000; ++i)
            {
                // 100 ݺ    û 
                if ((i % 100) == 0)
                {
                    if (tg1.is_canceling())
                    {
                        //  û Ǹ ̴ ۾ 
                        wcout << L"The t5 was canceled." << endl;
                        break;
                    }
                }

                // TODO: ۾ 
            }
        });

        // ڽ ½ũ ϰ  
        tg2.run(t4);
        tg2.run(t5);
        tg2.wait();
    });

    // ڽ ½ũ t2 
    auto t2 = make_task([&tg1] {
        for (int i = 0; i < 1000000; ++i)
        {
            // 100 ݺ    û 
            if ((i % 100) == 0)
            {
                if (tg1.is_canceling())
                {
                    //  û Ǹ ̴ ۾ 
                    wcout << L"The t2 was canceled." << endl;
                    break;
                }
            }

            // TODO: ۾ 
        }
    });

    // ڽ ½ũ t3 
    auto t3 = make_task([&tg1] {
        for (int i = 0; i < 1000000; ++i)
        {
            // 100 ݺ    û 
            if ((i % 100) == 0)
            {
                if (tg1.is_canceling())
                {
                    //  û Ǹ ̴ ۾ 
                    wcout << L"The t3 was canceled." << endl;
                    break;
                }
            }

            // TODO: ۾ 
        }
    });

    // ڽ ½ũ ϰ  
    tg1.run(t1);
    tg1.run(t2);
    tg1.run(t3);
    task_group_status status = tg1.wait();

    // ½ũ ׷  
    wcout << L"tg1 status: " << get_status_string(status) << endl;
}
